<template>
  <div class="createUser">
    <main>
      <div class="mainContent">
        <el-form ref="user" label-width="140px" autoComplete="on" :model="user" :rules="createUserRules"
                 label-position="right">
          <!-- 用户名称 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="用户名称:" prop="username">
                <el-input v-model="user.username" placeholder="填写用户名称" autoComplete="new-username">
                </el-input>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 用户密码 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItems" label="用户密码:" prop="password" >
                <el-input v-model="user.password" type="password" autoComplete="new-password"
                          placeholder="请输入用户密码"></el-input>
              </el-form-item>
            </div>
            <div class="item-right"></div>
            <!-- 重新输入密码即为修改，密码有效期默认为3个月 -->
          </div>
          <!-- 所属用户姓名 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="所属用户姓名:" prop="nickName">
                <el-input v-model="user.nickName" placeholder="请填写用户姓名"></el-input>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 性别 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="性别:" prop="sex">
                <el-radio-group v-model="user.sex">
                  <el-radio :label="1">男</el-radio>
                  <el-radio :label="0">女</el-radio>
                </el-radio-group>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 是否党员 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="是否党员:" prop="isDy">
                <el-radio-group v-model="user.isDy">
                  <el-radio :label="1">是</el-radio>
                  <el-radio :label="0">否</el-radio>
                </el-radio-group>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 所属手机号码 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="所属手机号码:" prop="mobile">
                <el-input v-model="user.mobile" maxlength="11" placeholder="请填写手机号码"></el-input>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 邮箱地址 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="邮箱地址:" prop="email">
                <el-input v-model="user.email" placeholder="请填写邮箱地址"></el-input>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 选择角色 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="选择角色:" prop="role">
                <el-select v-model="user.role" placeholder="请选择所属角色" multiple collapse-tags>
                  <el-option v-for="item in roleList" :key="item.id" :label="item.name"
                             :value="item.id">
                  </el-option>
                </el-select>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 用户类型 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="用户类型:" prop="userType">
                <el-select v-model="user.userType" placeholder="请选择用户类型">
                  <el-option v-for="item in typeList" :key="item.id" :label="item.name"
                             :value="item.id">
                  </el-option>
                </el-select>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 座机/分机 -->
          <div class="user-item sp-item">
            <div class="item-left">
              <el-form-item label="座机/分机:" prop="zjarea">
                <el-input v-model="user.zjarea" placeholder="电话区号">
                </el-input>
              </el-form-item>
              <el-form-item prop="zjnumber" class="left-px">
                <el-input v-model="user.zjnumber" placeholder="电话号码">
                </el-input>
              </el-form-item>
              <el-form-item prop="zjother" class="left-px">
                <el-input v-model="user.zjother" placeholder="分机号码">
                </el-input>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 所属部门 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="所属部门:" prop="departmentId">
                <el-select v-model="user.departmentId" placeholder="请选择所属部门" @change="getDepartName">
                  <el-option :value="mylabel">
                    <el-tree ref="tree" :check-strictly="true" :data="departList"
                             :props="defaultProps" show-checkbox @check-change="handleCheck"
                             default-expand-all node-key="id">
                    </el-tree>
                  </el-option>
                </el-select>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 当前职务 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="当前职务:" prop="jobTitle">
                <el-input v-model="user.jobTitle" placeholder="请输入当前职务"></el-input>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 填写所属mac地址 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="填写所属mac地址:" prop="mac">
                <el-input v-model="user.mac" placeholder="请填写所属mac地址"></el-input>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <!-- 填写所属ip地址 -->
          <div class="user-item">
            <div class="item-left">
              <el-form-item class="optionItem" label="填写所属ip地址:" prop="ip">
                <el-input v-model="user.ip" placeholder="请填写所属ip地址"></el-input>
              </el-form-item>
            </div>
            <div class="item-right"></div>
          </div>
          <el-form-item>
            <div class="optionBtn">
              <el-button type="primary" class="btn submit" @click.native.prevent="handleUser">提交
              </el-button>
              <el-button class="btn reset" @click.native.prevent="resetForm">重置</el-button>
            </div>
          </el-form-item>
        </el-form>

      </div>
    </main>
  </div>
</template>
<script>
import { getTypeList } from '@/utils/helper'
export default {
  data() {
    const validateNickname = (rule, value, callback) => {
      if (!value) {
        callback(new Error("所属姓名不能为空"));
      } else {
        callback();
      }
    };
    const validatePass = (rule, value, callback) => {
      //必须包含字母、数字、长度再6-16位之间
      var rep =/^(?=.*\d)(?=.*[a-z])(?=.*[A-Z])[a-zA-Z0-9]{8,16}$/;
          if (!rep.test(value) ) {
            callback(new Error("密码长度8到16位且密码中的字符必须包含字母大写和字母小写和必须包含数字，不能包含空格"));
          } else {
            callback();
          }

      // if (!value) {
      //     callback(new Error("用户密码不能为空"));
      // } else {
      //     if (value.length < 6 || value.length > 16){
      //         callback(new Error("用户密码长度不合法"));
      //     }else {
      //         const rep = /^\w+$/;
      //         if (!rep.test(value)) {
      //             callback(new Error("密码只能是以数字、26个英文字母或者下划线组成的字符串"));
      //         } else {
      //             callback();
      //         }
      //     }
      // }
    };
    const validateTruename = (rule, value, callback) => {
      if (!value) {
        callback(new Error("用户姓名不能为空"));
      } else {
        callback();
      }
    };
    const validatePhone = (rule, value, callback) => {
      if (!value) {
        callback(new Error("手机号码不能为空"));
      } else {
        const rep = /(^1[3|4|5|7|8|9]\d{9}$)|(^09\d{8}$)/
        if (!rep.test(value)) {
          callback("请输入正确的手机号码");
        } else {
          callback();
        }
      }
    };
    const validateMail = (rule, value, callback) => {
      if (value) {
        const rep = /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/;
        if (!rep.test(value)) {
          callback(new Error("请输入正确的邮箱"))
        } else {
          callback();
        }
      } else {
        callback();
      }
    };
    const validateRole = (rule, value, callback) => {
      if (!value) {
        callback(new Error("所属角色不能为空"));
      } else {
        callback()
      }
    };
    const validateType = (rule, value, callback) => {
      if (!value) {
        callback(new Error("用户类型不能为空"));
      } else {
        callback()
      }
    };
    const validateDepartment = (rule, value, callback) => {
      if (!value) {
        callback(new Error("请选择用户部门"));
      } else {
        callback()
      }
    };
    const validateWork = (rule, value, callback) => {
      if (!value) {
        callback(new Error("用户当前职务不能为空"));
      } else {
        callback();
      }
    };
    const validateMac = (rule, value, callback) => {
      if (value) {
        callback();
      } else {
        callback()
      }
    };
    const validateIp = (rule, value, callback) => {
      if (value) {
        callback();
      } else {
        callback()
      }
    };
    return {
      user: {
        nickName: '',
        password: '',
        username: '',
        sex: 1,
        isDy: 0,
        mobile: '',
        email: '',
        role: null,
        userType: null,
        zjarea: '',
        zjnumber: '',
        zjother: '',
        departmentId: null,
        jobTitle: null,
        mac: '',
        ip: '',
      },
      createUserRules: {
        nickName: [
          { required: true, trigger: "blur", validator: validateNickname },
        ],
        password: [
          { required: true, trigger: "blur", validator: validatePass },
        ],
        username: [
          { required: true, trigger: "blur", validator: validateTruename },
        ],
        sex: [
          { required: true, trigger: "blur" },
        ],
        isDy: [
          { required: true, trigger: "blur" },
        ],
        mobile: [
          { required: true, trigger: "blur", validator: validatePhone },
        ],
        email: [
          { required: true, trigger: "blur", validator: validateMail },
        ],
        role: [
          { required: true, trigger: "change", validator: validateRole },
        ],
        userType: [
          { required: true, trigger: "change", validator: validateType },
        ],
        zj: [
          { required: false, trigger: "blur" },
        ],
        departmentId: [
          { required: true, trigger: "change", validator: validateDepartment },
        ],
        jobTitle: [
          { required: true, trigger: "blur", validator: validateWork },
        ],
        mac: [
          { required: false, trigger: "blur", validator: validateMac },
        ],
        ip: [
          { required: false, trigger: "blur", validator: validateIp },
        ],
      },
      roleList: [

      ],
      typeList: [

      ],
      departList: [],
      mylabel: '',
      defaultProps: {
        children: 'children',
        label: 'departName',
        disabled: (data, node) => {
          if (node.level === 1 && node.childNodes.length !== 0) {
            return !data.leaf
          }
        }
      },
      selectOrg: {
        orgsid: []
      },
    }
  },
  created() {
    // 获取角色列表
    this.getRoleList();
    // 获取用户类型
    this.getUserTypeList();
    // 获取部门
    this.getDepartList();
  },
  methods: {
    // 提交注册
    handleUser() {
      this.$refs['user'].validate((valid) => {
        console.log(valid);
        if (valid) {
          const { user, selectOrg } = this;
          console.log(user);
          this.$axios.post('sccg/admin/register', {
            departmentId: selectOrg.orgsid[0],
            email: user.email,
            icon: '',
            isDy: `${user.isDy}`,
            jobTitle: user.jobTitle,
            mobile: user.mobile,
            note: '',
            roleIds: user.role,
            // nickName: user.nickName,
            sex: `${user.sex}`,
            password: user.password,
            userType: user.userType,
            username: user.username,
            zj: user.zjarea + `${user.zjnumber}` + user.zjother,
            nickName: user.nickName
            // departName:user.departName,
          }).then(res => {
            if (res.code === 200) {
              console.log(1);
              this.$message({
                type: 'success',
                message: res.message,
              })
              this.$emit('sendDialog', { flag: false });
            } else if (res.code === 500 && res.message === "操作失败") {
              this.$message({
                type: 'warning',
                message: '该用户已注册'
              })
            } else {
              this.$message({
                type: 'warning',
                message: res.message
              })
            }
          })
        } else {
          return false
        }
      })
    },
    // 获取角色列表
    getRoleList() {
      this.$axios({
        method: 'get',
        url: 'sccg/role/listAll',
      })
          .then(res => {
            this.roleList = res.data;
          })
    },
    // 重置表单
    resetForm() {
      this.$refs['user'].resetFields();
    },
    // 获得部门名称
    getDepartName(data) {
      this.departList.forEach(item => {
        if (item.id === data) {
          this.user.departName = item.departName
        }
      })
    },
    // 获取用户类型
    async getUserTypeList() {
      this.typeList = await getTypeList(1, '07');
    },
    // 获取部门树
    getDepartList() {
      this.$axios({
        method: 'get',
        url: 'sccg/depart/tree'
      })
          .then(res => {
            this.departList = res.data;
          })
    },
    handleCheck(data, checked) {
      this.user.departmentId = data.departName;
      // 获取当前选择的id在数组中的索引
      const indexs = this.selectOrg.orgsid.indexOf(data.id)
      // 如果不存在数组中，并且数组中已经有一个id并且checked为true的时候，代表不能再次选择。
      if (indexs < 0 && this.selectOrg.orgsid.length === 1 && checked) {
        this.$message({
          message: '只能选择一个部门！',
          type: 'warning',
          showClose: true
        })
        // 设置已选择的节点为false 很重要
        this.$refs.tree.setChecked(data, false)
      } else if (this.selectOrg.orgsid.length === 0 && checked) {
        // 发现数组为空 并且是已选择
        // 防止数组有值，首先清空，再push
        this.selectOrg.orgsid = []
        this.selectOrg.orgsid.push(data.id)
      } else if (
          indexs >= 0 &&
          this.selectOrg.orgsid.length === 1 &&
          !checked
      ) {
        // 再次直接进行赋值为空操作
        this.selectOrg.orgsid = []
        this.user.departmentId = '';
      }
    },
  },
  props: ['sendDialog']
}
</script>
<style lang="scss" scoped>
.createUser {
  border-radius: 1px;
  background-color: #09152f;

  main {
    text-align: left;
    padding: 0 55px;
    background-color: #09152f;
    padding-bottom: 50px;
    padding-top: 20px;

    .mainContent {
      display: flex;
      // justify-content: center;
      margin-top: 50px;
      width: 100%;
      &::v-deep .el-form-item__label {
        color: #4b9bb7;
      }

      &::v-deep .el-input__inner {
        background-color: #09152f;
        border: 1px solid #17324c;
      }

      .el-form-item__content {
        width: 400px;
        .el-select {
          width: 100%;
        }
      }

      .sp-item {
        .item-left{
          display: flex;
        }
      }

      .user-item {
        display: flex;
        justify-content: space-between;
        .item-left {
          width: 500px;
        }
        .item-right {
          line-height: 40px;
          color: #4b9bb7;
          font-size: 12px;
          // margin-left: 16px;
        }

        .left-px :deep(.el-form-item__content) {
          margin-left: 0px !important;
        }
      }

      .optionBtn {
        display: flex;
        margin-top: 20px;

        .btn {
          padding: 12px 50px;
        }
      }

    }
  }
}
</style>
